///////////////////////////////////////////////////////////////////////////
//
//   Copyright 2006 Alberto González Palomo
//   Author: Alberto González Palomo <http://www.matracas.org>
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
/////////////////////////////////////////////////////////////////////////////

function Graphics_context_2d_PS(width, height)
{
  var content;
  content = "";
    
  this.lineWidth = 1.0;
  this.watch("lineWidth", public_property_changed);
    
  function public_property_changed(property, old_value, new_value)
  {
    switch (property)
      {
      case "lineWidth":
        content += String(new_value) + " setlinewidth\n";
        break;
      default:
        // Ignore any unsupported properties.
        break;
      }
  }
    
  function save()
  { content += "gsave\n"; }
  function restore()
  { content += "grestore\n"; }
  function clearRect(x, y, w, h)
  {
    //if (0 == x && 0 == y && width == w && height == h)
    //  {
    //    content += "erasepage\n";
    //  }
  }
  function translate(x, y)
  { content += x + " " + y + " translate\n"; }
  function scale(x, y)
  { content += x + " " + y + " scale\n"; }
  function strokeStyle(style)
  { stroke_style = translate_style(style); }
  function fillStyle(style)
  { fill_style = translate_style(style); }
  function beginPath() { content += "newpath\n" }
  function moveTo(x, y) { content += String(x) + " " + y + " moveto\n"; }
  function lineTo(x, y) { content += String(x) + " " + y + " lineto\n"; }
  function arc(x, y, radius, begin, end, clockwise)
  {
    content += String(x) + " " + y + " " + radius + " " + begin + " " + end;
    if (clockwise) content += " arcn";
    else           content += " arc";
  }
  function closePath() { content += "closepath\n" }
  function stroke()
  {
    if (stroke_style) content += stroke_style + "closepath\neofill\n";
  }
  function fill()
  {
    if (fill_style) content += fill_style + "closepath\neofill\n";
  }
    
  function translate_style(style)
  {
    var match;
    match = style.match(/^rgb\(([^,]+),([^,]+),([^,\)]+)\)/);
    if (match)
      {
        return match(1) + " " + match[2] + " " + match[3]
          + " setrgbcolor\n";
      }
    match = style.match(/^rgba\(([^,]+),([^,]+),([^,]+),([^,\)]+)\)/);
    if (match)
      {
        if (parseFloat(match(4)) > 0.5)
          {
            return match(1) + " " + match[2] + " " + match[3]
              + " setrgbcolor\n";
          }
      }
      
    return undefined;
  }
    
  function toString()
  {
    return ("%!PS-Adobe-2.0\n%%Creator: Algebra 1.0 http://www.matracas.org/algebra\n%%Pages: 1\n%%Orientation: Portrait\n%%BoundingBox: 0 0 " + width + " " + height + "\n%%HiResBoundingBox: 0.0000000 0.0000000 " + width.toFixed(5) + " " + height.toFixed(5) + "\n%%EndComments\n%%Page: 1 1\n"
            + content
            + "\nshowpage\n%EOF\n"
            );
  }
}
