///////////////////////////////////////////////////////////////////////////
//
//   Copyright 2006 Alberto González Palomo
//   Author: Alberto González Palomo <http://www.matracas.org>
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
/////////////////////////////////////////////////////////////////////////////

function Graphics_context_2d_SVG(width, height)
{
  var content;
  content = "";
  var context_stack;
  context_stack = new Array();
  function context()
  {
    this.lineWidth = 1.0;
    this.path = ""
      this.style = "";
  }
  context.push(new context());
  var current_context;
  current_context = context_stack[context_stack.length - 1];
    
  this.lineWidth = 1.0;
  this.watch("lineWidth", public_property_changed);
    
  function public_property_changed(property, old_value, new_value)
  {
    switch (property)
      {
      case "lineWidth":
        //content += String(new_value) + " setlinewidth\n";
        break;
      default:
        // Ignore any unsupported properties.
        break;
      }
  }
    
  function save()
  {
    context_stack.push(new context());
    current_context = context_stack[context_stack.length - 1];
  }
  function restore()
  {
    if (current_context.transformation)
      {
        content = "<g" + current_context.transformation + ">\n"
          + content
          + "</g>\n";
      }
    context_stack.pop();
    current_context = context_stack[context_stack.length - 1];
  }
  function clearRect(x, y, w, h)
  {
  }
  function translate(x, y)
  {
    if (current_context.transformation)
      {
        current_context.transformation += " translate(" + x + ", " + y + ")";
      }
    else
      {
        current_context.transformation = " translate(" + x + ", " + y + ")";
      }
  }
  function scale(x, y)
    if (current_context.transformation)
      {
        current_context.transformation += " scale(" + x + ", " + y + ")";
      }
    else
      {
        current_context.transformation = " scale(" + x + ", " + y + ")";
      }
  function strokeStyle(style)
  { stroke_style = style; }
  function fillStyle(style)
  { fill_style = style; }
  function beginPath() { current_context.path = ""; }
  function moveTo(x, y) { current_context.path += " M" + x + " " + y; }
  function lineTo(x, y) { current_context.path += " L" + x + " " + y; }
  function arc(x, y, radius, begin, end, clockwise)
  {
  }
  function closePath() { current_context.path += " Z"; }
  function stroke()
  {
    if (stroke_style)
      {
        content += "<path d=\"" + current_context.path + "\""
          + " style=\""
          + "stroke:" + current_context.stroke_style + ";"
          + "stroke-width:" + current_context.lineWidth + ";"
          + "\""
          + "/>";
      }
  }
  function fill()
  {
    if (fill_style)
      {
        content += "<path d=\"" + current_context.path + "\""
          + " style=\""
          + "fill:" + current_context.stroke_style + ";"
          + "\""
          + "/>";
      }
  }
    
  function toString()
  {
    return ("<?xml version=\"1.0\" standalone=\"no\"?>\n<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 1.1//EN\" \"http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd\">\n<svg width=\"" + width + "px\" height=\"" + height + "px\" viewBox=\"0 0 " + width + " " + height + "\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">"
            + content
            + "\n</svg>\n"
            );
  }
}
