///////////////////////////////////////////////////////////////////////////
//
//   Copyright 2005, 2006 Alberto González Palomo
//   Author: Alberto González Palomo <http://www.matracas.org>
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
/////////////////////////////////////////////////////////////////////////////

function ask_yacas(expression)
{
  var host;
  var port;
  var transportService;
  var transport;
  var outstream;
  var stream;
  var scriptablestream;
  var pump;
  
  var yacasListener =
    {
      onStartRequest: function(request, context){},
      onStopRequest: function(request, context, status){
        instream.close();
        outstream.close();
      },
      onDataAvailable: function(request, context, inputStream, offset, count){
        alert(scriptablestream.read(count));
      }
    };
  
  if (expression)
    {
      host = "127.0.0.1";
      port = "9734";
      transportService = Components
        .classes["@mozilla.org/network/socket-transport-service;1"]
        .getService(Components.interfaces.nsISocketTransportService);
      transport = transportService.createTransport(null,0,host,port,null);
      
      outstream = transport.openOutputStream(0,0,0);
      outstream.write(expression,expression.length);
      
      stream = transport.openInputStream(0,0,0);
      scriptablestream = Components
        .classes["@mozilla.org/scriptableinputstream;1"]
        .createInstance(Components.interfaces.nsIScriptableInputStream);
      scriptablestream.init(stream);
      
      pump = Components
        .classes["@mozilla.org/network/input-stream-pump;1"].
        createInstance(Components.interfaces.nsIInputStreamPump);
      pump.init(stream, -1, -1, 0, 0, false);
      pump.asyncRead(yacasListener,null);
    }
}

// E4X did not work for me, so the next line is irrelevant for now, but I'm leaving it here for later.
//default xml namespace = new Namespace("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
// Instead, to reduce the pain of using normal JS, here is a helper function:
function e(name, attributes, children)
{
  var element;
  element = document.createElement(name);
  if (attributes)
    for (var a in attributes) element.setAttribute(a, attributes[a]);
  if (children)
    for (var c in children)
      {
        if ("string" == typeof(children[c]))
          element.appendChild(document.createTextNode(children[c]));
        else
          element.appendChild(children[c]);
      }
  
  return element;
}

var kernel;// The evaluation kernel of the CAS.

function init()
{
  kernel = new Kernel();
  new_notebook();
  status_message("← Pick your favourite syntax from our nice selection.");
}

function quit()
{
}

function check_close()
{
  return true;
}

function close_window()
{
  if (check_close()) window.close();
}

function print_notebook()
{
  var frame;
  frame = get_current_frame();
  if (frame) frame.contentWindow.print();
}

function get_current_frame()
{
  var frame;
  
  var tabbox;
  tabbox = document.getElementById("notebook-binder");
  if (tabbox && tabbox.selectedPanel)
    {
      frame = tabbox.selectedPanel.firstChild;
      while (frame && frame.nodeName != "browser" && frame.nextSibling)
        frame = frame.nextSibling;
    }
  
  return frame;
}

function set_style(identifier)
{
  var frame;
  frame = get_current_frame();
  if (frame)
    {
      frame.setAttribute("src",
                         "chrome://algebra/content/styles/" + identifier
                         + "/notebook.xul");
    }
}

function new_parser()
{
  var parser;
  try               { parser = new QMath("chrome://algebra/content/parser"); }
  catch (exception) { message(exception); }
  
  return parser;
}

function new_notebook()
{
  var tabbox;
  var tabs;
  var tabpanels;
  tabbox    = document.getElementById("notebook-binder");
  tabs      = document.getElementById("notebook-binder-tabs");
  tabpanels = document.getElementById("notebook-binder-tabpanels");
  var new_tab;
  var new_tabpanel;
  // Using E4X didn't work, either settng the default namespace or not:
  // Error: uncaught exception: [Exception... "Node cannot be inserted at the specified point in the hierarchy"  code: "3" nsresult: "0x80530003 (NS_ERROR_DOM_HIERARCHY_REQUEST_ERR)"  location: "chrome://algebra/content/algebra.js Line: 67"]
  //new_tab = <tab label="New notebook"/>;
  new_tab = e("tab", {"label":"New notebook"});
  new_tabpanel = e("tabpanel", {}, [e("browser", {"flex":"1"})] );
  tabs.appendChild(new_tab);
  //tabpanels.appendChild(<tabpanel><browser flex="1" src="about:blank"/></tabpanel>);
  tabpanels.appendChild(new_tabpanel);
  tabbox.selectedTab = new_tab;
  document.getElementById("style-menu-button").selectedItem.doCommand();
}

function close_notebook()
{
  var tabbox;
  var tabs;
  var tabpanels;
  tabbox    = document.getElementById("notebook-binder");
  tabs      = document.getElementById("notebook-binder-tabs");
  tabpanels = document.getElementById("notebook-binder-tabpanels");
  var selected_tab;
  var selected_panel;
  selected_tab = tabbox.selectedTab;
  selected_panel = tabbox.selectedPanel;
  if (selected_tab && selected_panel)
    {
      if (selected_tab.previousSibling)
        tabbox.selectedTab = selected_tab.previousSibling;
      else if (selected_tab.nextSibling)
        tabbox.selectedTab = selected_tab.nextSibling;
      tabs.removeChild(selected_tab);
      tabpanels.removeChild(selected_panel);
    }
}

function set_title(title)
{
  title = title.replace(/\n/, "");
  if (title.length > 40) title = title.substring(0, 40) + "...";
  document.title = title + " - Algebra";
  var tabbox;
  tabbox = document.getElementById("notebook-binder");
  if (tabbox.selectedTab) tabbox.selectedTab.label = title;
}

function zoom(factor)
{
  var frame;
  frame = get_current_frame();
  if (frame) frame.markupDocumentViewer.textZoom = factor;
}

function zoom_reset()
{
  zoom(1.0);
}

function zoom_increase()
{
  var size_menu_button;
  size_menu_button = document.getElementById("size-menu-button");
  if (! size_menu_button.lastChild.lastChild.getAttribute("selected"))
    {
      size_menu_button.selectedIndex += 1;
      size_menu_button.selectedItem.doCommand();
    }
}

function zoom_decrease()
{
  var size_menu_button;
  size_menu_button = document.getElementById("size-menu-button");
  if (! size_menu_button.firstChild.firstChild.getAttribute("selected"))
    {
      size_menu_button.selectedIndex -= 1;
      size_menu_button.selectedItem.doCommand();
    }
}

function insert(text)
{
  var frame;
  frame = get_current_frame();
  if (frame) frame.contentWindow.insert(text);
}

function status_message(message)
{
  document.getElementById("status-message").label = message;
}

function message(message)
{
  status_message(message);
  alert(message);
}
