<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:om="http://www.openmath.org/OpenMath"
  xmlns:transformiix="http://www.mozilla.org/TransforMiix"
  xmlns="http://www.openmath.org/OpenMath"
  version="1.0">
  
  <xsl:output method="xml"/>
  
  <xsl:template match="/">
    <xsl:apply-templates/>
  </xsl:template>
  
  <xsl:template match="om:OMOBJ">
    <OMOBJ unchanged="true"><xsl:apply-templates/></OMOBJ>
  </xsl:template>
  
  <xsl:template match="transformiix:result">
    <xsl:apply-templates select="*[1]"/>
  </xsl:template>
  
  <xsl:template match="*">
    <xsl:call-template name="copy-and-descend"/>
  </xsl:template>
  
  <xsl:template name="copy-and-descend">
    <xsl:copy>
      <xsl:copy-of select="@*"/>
      <xsl:attribute name="unchanged">true</xsl:attribute>
      <xsl:apply-templates/>
    </xsl:copy>
  </xsl:template>
  
  <xsl:template match="om:OMI">
    <OMI unchanged="true"><xsl:value-of select="text()"/></OMI>
  </xsl:template>
  
  <xsl:template match="om:OMSTR">
    <OMSTR unchanged="true"><xsl:value-of select="text()"/></OMSTR>
  </xsl:template>
  
</xsl:stylesheet>
