<?xml version="1.0"?>
<xsl:stylesheet xmlns:a="http://www.matracas.org/ns/algebra" xmlns:om="http://www.openmath.org/OpenMath" xmlns="http://www.openmath.org/OpenMath" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  
  <xsl:output method="xml"/>
  
  
  
  
  <xsl:template match="om:OMA[om:*[1][self::om:OMS][@cd='arith1' and @name='unary_minus']][count(om:*) = 2 and om:OMI]">
    <xsl:variable name="number" select="normalize-space(om:OMI)"/>
    <xsl:choose>
      <xsl:when test="starts-with($number, '-')">
        <OMI><xsl:value-of select="substring-after($number, '-')"/></OMI>
      </xsl:when>
      <xsl:when test="substring-after($number, '+')">
        <OMI><xsl:text>-</xsl:text><xsl:value-of select="substring-after($number, '+')"/></OMI>
      </xsl:when>
      <xsl:otherwise>
        <OMI><xsl:text>-</xsl:text><xsl:value-of select="$number"/></OMI>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="om:OMA[om:*[1][self::om:OMS][@cd='arith1' and @name='unary_minus']][count(om:*) = 2 and om:*[2][self::om:OMA[om:*[self::om:OMS][@cd='arith1' and @name='unary_minus']]]]">
    <xsl:apply-templates select="om:*[2]/om:*[2]"/>
  </xsl:template>
  
  <xsl:template match="om:OMA[om:*[1][self::om:OMS][@cd='arith1' and @name='unary_minus']][count(om:*) = 2 and om:OMF]">
    <xsl:variable name="number" select="normalize-space(om:OMF/@dec)"/>
    <xsl:choose>
      <xsl:when test="substring-after($number, '-')">
        <OMF dec="{substring-after($number, '-')}"/>
      </xsl:when>
      <xsl:when test="substring-after($number, '+')">
        <OMF dec="-{substring-after($number, '+')}"/>
      </xsl:when>
      <xsl:otherwise>
        <OMF dec="-{$number}"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="om:OMA[om:*[1][self::om:OMS][@cd='arith1' and @name='plus']][count(om:*) = 2]">
    <xsl:apply-templates select="om:*[2]"/>
  </xsl:template>
  
  
  
  <xsl:template match="om:OMA[count(om:*) = 3][om:*[1][self::om:OMS][@cd='arith1' and @name='plus']][om:*[3][self::om:OMI[text() = '0']]]"><xsl:apply-templates select="om:*[2]"/></xsl:template>
  
  
  
  <xsl:template match="om:OMA[om:*[1][self::om:OMS][@cd='arith1' and @name='plus']][om:OMA/om:OMS[@cd='arith1' and @name='plus']]">
    <xsl:copy>
      <xsl:for-each select="*">
        <xsl:choose>
          <xsl:when test="self::om:OMA/om:*[1][self::om:OMS][@cd='arith1' and @name='plus']">
            <xsl:apply-templates select="om:*[position() &gt; 1]"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:apply-templates select="."/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:for-each>
    </xsl:copy>
  </xsl:template>
  
  <xsl:template match="om:OMA[om:*[1][self::om:OMS][@cd='arith1' and @name='minus']][count(om:OMI) = 1 and om:OMA[om:*[1][self::om:OMS[@cd='arith1' and @name='plus']] and om:OMI]]">
    <xsl:variable name="processed_position" select="1 + count(om:OMI[1]/preceding-sibling::om:*)"/>
    <xsl:variable name="inner_app" select="om:OMA[om:*[1][self::om:OMS[@cd='arith1' and @name='plus']] and om:OMI][1]"/>
    <xsl:variable name="inner_app_position" select="1 + count($inner_app/preceding-sibling::om:*)"/>
    <xsl:variable name="inner_processed_position" select="1 + count($inner_app/om:OMI[1]/preceding-sibling::om:*)"/>
    <xsl:choose>
      <xsl:when test="$processed_position = 1">
        
        <xsl:copy>
          <xsl:apply-templates select="om:*[1]"/>
          <om:OMA>
            <om:OMS cd="arith1" name="plus"/>
            <xsl:apply-templates select="om:*[$processed_position]"/>
            <xsl:apply-templates select="$inner_app/om:*[$inner_processed_position]"/>
          </om:OMA>
          <xsl:for-each select="position() != $processed_position">
            <xsl:choose>
              <xsl:when test="position() = $inner_app_position">
                <xsl:copy>
                  <xsl:apply-templates select="position() != $inner_processed_position"/>
                </xsl:copy>
              </xsl:when>
              <xsl:otherwise>
                <xsl:apply-templates select="."/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:for-each>
        </xsl:copy>
      </xsl:when>
      <xsl:when test="$inner_app_position = 1">
        
        <xsl:call-template name="copy-and-descend"/>
        
      </xsl:when>
      <xsl:when test="$processed_position &lt; $inner_app_position">
        
        <xsl:call-template name="copy-and-descend"/>
        
      </xsl:when>
      <xsl:otherwise>
        
        <xsl:call-template name="copy-and-descend"/>
        
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="om:OMA[om:*[1][self::om:OMS][@cd='arith1' and @name='plus']][count(om:OMI) &gt;= 2]">
    <xsl:variable name="processed_position" select="1 + count(om:OMI[1]/preceding-sibling::om:*)"/>
    <xsl:choose>
      <xsl:when test="count(om:*[local-name() != 'OMI']) &gt; 1">
        <xsl:copy>
          <xsl:apply-templates select="om:*[position() &lt; $processed_position and local-name() != 'OMI']"/>
          <OMI><xsl:value-of select="sum(om:OMI)"/></OMI>
          <xsl:apply-templates select="om:*[position() &gt; $processed_position and local-name() != 'OMI']"/>
        </xsl:copy>
      </xsl:when>
      <xsl:otherwise>
        <OMI><xsl:value-of select="sum(om:OMI)"/></OMI>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="om:OMA[om:*[1][self::om:OMS][@cd='arith1' and @name='minus']][count(om:OMI) &gt;= 2]">
    <xsl:variable name="processed_position" select="1 + count(om:OMI[1]/preceding-sibling::om:*)"/>
    <xsl:choose>
      <xsl:when test="count(om:*[local-name() != 'OMI']) &gt; 1">
        <xsl:copy>
          <xsl:variable name="items_before_first_integer" select="om:*[position() &lt; $processed_position and local-name() != 'OMI']"/>
          <xsl:choose>
            <xsl:when test="$items_before_first_integer">
              <xsl:apply-templates select="$items_before_first_integer"/>
              <OMI><xsl:value-of select="sum(om:OMI)"/></OMI>
            </xsl:when>
            <xsl:otherwise>
              <OMI><xsl:value-of select="number(om:OMI[1])-sum(om:OMI[position() != 1])"/></OMI>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:apply-templates select="om:*[position() &gt; $processed_position and local-name() != 'OMI']"/>
        </xsl:copy>
      </xsl:when>
      <xsl:otherwise>
        <OMI><xsl:value-of select="number(om:OMI[1])-sum(om:OMI[position() != 1])"/></OMI>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  
  
  
  
  
  
  
</xsl:stylesheet>
