<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

  <xsl:output method="xml" indent="yes"/>

  <xsl:template match="/">
    <bork>
      <xsl:apply-templates/>
    </bork>
  </xsl:template>
  
  <xsl:template match="ops">
    <xsl:variable name="list" select="*[local-name() != 'text' or @literal != ' ']"/>
    <xsl:variable name="operators" select="$list[position() mod 2 = 0]"/>
    <xsl:variable name="last_operator_token" select="$operators[last()]/@literal"/>
    <xsl:variable name="run_of_same_operator"
      select="$operators[@literal = $last_operator_token and not(following-sibling::*[position() mod 2 = 0][@literal != $last_operator_token])]"/>
    <xsl:variable name="position_of_first_argument_to_same_operator"
      select="count($run_of_same_operator[1]/preceding-sibling::*) + 1 - 1"/>
    <list>
      <xsl:for-each select="$list">
        <l name="{@literal}"/>
      </xsl:for-each>
    </list>
    <first-operator position="{count($operators[last()]/preceding-sibling::*) + 1}"/>
    <position-of-first-argument-to-same-operator value="{$position_of_first_argument_to_same_operator}"/>
    <operators>
      <xsl:for-each select="$run_of_same_operator">
        <o name="{@literal}" position="{position()}" real-position="{count(preceding-sibling::*)+1}"/>
      </xsl:for-each>
    </operators>
  </xsl:template>
  
</xsl:stylesheet>
