<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE xsl:stylesheet [
  <!ENTITY And "&#x2227;">
  <!ENTITY DoubleLeftRightArrow "&#x21D4;">
  <!ENTITY DoubleRightArrow "&#x21D2;">
  <!ENTITY Or "&#x2228;">
  <!ENTITY not "&#x00AC;">
  <!ENTITY ExponentialE "&#x2147;">
  <!ENTITY gamma "&#x03B3;">
  <!ENTITY ImaginaryI "&#x2148;">
  <!ENTITY infin "&#x221E;">
  <!ENTITY pi "&#x03C0;">
  <!ENTITY ForAll "&#x2200;">
  <!ENTITY Exists "&#x2203;">
  <!ENTITY GreaterEqual "&#x2265;">
  <!ENTITY leq "&#x2264;">
  <!-- ENTITY gt &#x; -->
  <!-- ENTITY lt &#x; -->
  <!ENTITY times "&#x00D7;">
  <!ENTITY emptyset "&#xEEFB;">
  <!ENTITY Element "&#x2208;">
  <!ENTITY cap "&#x2229;">
  <!ENTITY RightArrow "&#x2192;">
  <!ENTITY NotElement "&#x2209;">
  <!ENTITY NotSubset "&#x2284;">
  <!ENTITY subsetneqq "&#x228A;">
  <!ENTITY bsol "&#x005D;">
  <!ENTITY subset "&#x2282;">
  <!ENTITY cup "&#x222A;">
]>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:om="http://www.openmath.org/OpenMath"
  xmlns:m="http://www.w3.org/1998/Math/MathML"
  xmlns="http://www.w3.org/1999/xhtml"
  version="1.0">

  <xsl:output method="xml"/>

  <xsl:template match="om:OMS">
    <m:mo><xsl:value-of select="@cd"/>:<xsl:value-of select="@name"/></m:mo>
  </xsl:template>

  <xsl:template match="om:OMS[@cd='arith1']">
    <xsl:choose>
      <xsl:when test="@name='abs'">
        <m:mo>abs</m:mo>
      </xsl:when>
      <xsl:when test="@name='divide'">
        <m:mo>/</m:mo>
      </xsl:when>
      <xsl:when test="@name='gcd'">
        <m:mo>gcd</m:mo>
      </xsl:when>
      <xsl:when test="@name='lcm'">
        <m:mo>lcm</m:mo>
      </xsl:when>
      <xsl:when test="@name='minus'">
        <m:mo>&#8722;</m:mo>
      </xsl:when>
      <xsl:when test="@name='plus'">
        <m:mo>+</m:mo>
      </xsl:when>
      <xsl:when test="@name='power'">
        <m:mo>^</m:mo>
      </xsl:when>
      <xsl:when test="@name='product'">
        <m:mo>&#x220F;</m:mo>
      </xsl:when>
      <xsl:when test="@name='root'">
        <m:mo>root</m:mo>
      </xsl:when>
      <xsl:when test="@name='sum'">
        <m:mo>&#x2211;</m:mo>
      </xsl:when>
      <xsl:when test="@name='times'">
        <m:mo><!-- &#x2062; -->·</m:mo>
      </xsl:when>
      <xsl:when test="@name='unary_minus'">
        <m:mo>&#8722;</m:mo>
      </xsl:when>
      <xsl:otherwise>
        <m:mo><xsl:value-of select="@cd"/>:<xsl:value-of select="@name"/></m:mo>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="om:OMS[@cd='fns1']">
    <xsl:choose>
      <xsl:when test="@name='inverse'">
        <m:mo>inv</m:mo>
      </xsl:when>
      <xsl:when test="@name='lambda'">
        <m:mo>&#x03BB;</m:mo>
      </xsl:when>
      <xsl:otherwise>
        <m:mo><xsl:value-of select="@cd"/>:<xsl:value-of select="@name"/></m:mo>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="om:OMS[@cd='integer1']">
    <xsl:choose>
      <xsl:when test="@name='factorial'">
        <m:mo>!</m:mo>
      </xsl:when>
      <xsl:otherwise>
        <m:mo><xsl:value-of select="@cd"/>:<xsl:value-of select="@name"/></m:mo>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="om:OMS[@cd='logic1']">
    <xsl:choose>
      <xsl:when test="@name='and'">
        <m:mo>&And;</m:mo>
      </xsl:when>
      <xsl:when test="@name='equals'">
        <m:mo>&DoubleLeftRightArrow;</m:mo>
      </xsl:when>
      <xsl:when test="@name='implies'">
        <m:mo>&DoubleRightArrow;</m:mo>
      </xsl:when>
      <xsl:when test="@name='or'">
        <m:mo>&Or;</m:mo>
      </xsl:when>
      <xsl:when test="@name='not'">
        <m:mo>&not;</m:mo>
      </xsl:when>
      <xsl:otherwise>
        <m:mo><xsl:value-of select="@cd"/>:<xsl:value-of select="@name"/></m:mo>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="om:OMS[@cd='nums1']">
    <xsl:choose>
      <xsl:when test="@name='e'">
        <m:mn>&ExponentialE;</m:mn>
      </xsl:when>
      <xsl:when test="@name='gamma'">
        <m:mn>&gamma;</m:mn>
      </xsl:when>
      <xsl:when test="@name='i'">
        <m:mn>&ImaginaryI;</m:mn>
      </xsl:when>
      <xsl:when test="@name='infinity'">
        <m:mn>&infin;</m:mn>
      </xsl:when>
      <xsl:when test="@name='NaN'">
        <m:mn>NaN</m:mn>
      </xsl:when>
      <xsl:when test="@name='pi'">
        <m:mn>&pi;</m:mn>
      </xsl:when>
      <xsl:when test="@name='rational'">
        /
      </xsl:when>
      <xsl:otherwise>
        <m:mo><xsl:value-of select="@cd"/>:<xsl:value-of select="@name"/></m:mo>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="om:OMS[@cd='quant1']">
    <xsl:choose>
      <xsl:when test="@name='forall'">
        <m:mo>&ForAll;</m:mo>
      </xsl:when>
      <xsl:when test="@name='exists'">
        <m:mo>&Exists;</m:mo>
      </xsl:when>
      <xsl:otherwise>
        <m:mo><xsl:value-of select="@cd"/>:<xsl:value-of select="@name"/></m:mo>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="om:OMS[@cd='relation1']">
    <xsl:choose>
      <xsl:when test="@name='eq'">
        <m:mo>=</m:mo>
      </xsl:when>
      <xsl:when test="@name='geq'">
        <m:mo>&GreaterEqual;</m:mo>
      </xsl:when>
      <xsl:when test="@name='leq'">
        <m:mo>&leq;</m:mo>
      </xsl:when>
      <xsl:when test="@name='gt'">
        <m:mo>&gt;</m:mo>
      </xsl:when>
      <xsl:when test="@name='lt'">
        <m:mo>&lt;</m:mo>
      </xsl:when>
      <xsl:otherwise>
        <m:mo><xsl:value-of select="@cd"/>:<xsl:value-of select="@name"/></m:mo>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="om:OMS[@cd='set1']">
    <xsl:choose>
      <xsl:when test="@name='cartesian_product'">
        <m:mo>&times;</m:mo>
      </xsl:when>
      <xsl:when test="@name='emptyset'">
        <m:mi>&emptyset;</m:mi>
      </xsl:when>
      <xsl:when test="@name='in'">
        <m:mo>&Element;</m:mo>
      </xsl:when>
      <xsl:when test="@name='intersect'">
        <m:mo>&cap;</m:mo>
      </xsl:when>
      <xsl:when test="@name='map'">
        <m:mo>&RightArrow;</m:mo>
      </xsl:when>
      <xsl:when test="@name='notin'">
        <m:mo>&NotElement;</m:mo>
      </xsl:when>
      <xsl:when test="@name='notsubset'">
        <m:mo>&NotSubset;</m:mo>
      </xsl:when>
      <xsl:when test="@name='prsubset'">
        <m:mo>&subsetneqq;</m:mo>
      </xsl:when>
      <xsl:when test="@name='set'">
        <m:mo>set</m:mo>
      </xsl:when>
      <xsl:when test="@name='setdiff'">
        <m:mo>&bsol;</m:mo>
      </xsl:when>
      <xsl:when test="@name='size'">
        <m:mo>card</m:mo>
      </xsl:when>
      <xsl:when test="@name='subset'">
        <m:mo>&subset;</m:mo>
      </xsl:when>
      <xsl:when test="@name='suchthat'">
        <m:mo>|</m:mo>
      </xsl:when>
      <xsl:when test="@name='union'">
        <m:mo>&cup;</m:mo>
      </xsl:when>
      <xsl:otherwise>
        <m:mo><xsl:value-of select="@cd"/>:<xsl:value-of select="@name"/></m:mo>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="om:OMS[@cd='transc1']">
    <xsl:choose>
      <xsl:when test="@name='arccos'">
        <m:mo>arccos</m:mo>
      </xsl:when>
      <xsl:when test="@name='arccosh'">
        <m:mo>arccosh</m:mo>
      </xsl:when>
      <xsl:when test="@name='arccot'">
        <m:mo>arccot</m:mo>
      </xsl:when>
      <xsl:when test="@name='arccoth'">
        <m:mo>arccoth</m:mo>
      </xsl:when>
      <xsl:when test="@name='arccsc'">
        <m:mo>arccsc</m:mo>
      </xsl:when>
      <xsl:when test="@name='arccsch'">
        <m:mo>arccsch</m:mo>
      </xsl:when>
      <xsl:when test="@name='arcsec'">
        <m:mo>arcsec</m:mo>
      </xsl:when>
      <xsl:when test="@name='arcsech'">
        <m:mo>arcsech</m:mo>
      </xsl:when>
      <xsl:when test="@name='arcsin'">
        <m:mo>arcsin</m:mo>
      </xsl:when>
      <xsl:when test="@name='arcsinh'">
        <m:mo>arcsinh</m:mo>
      </xsl:when>
      <xsl:when test="@name='arctan'">
        <m:mo>arctan</m:mo>
      </xsl:when>
      <xsl:when test="@name='arctanh'">
        <m:mo>arctanh</m:mo>
      </xsl:when>
      <xsl:when test="@name='cos'">
        <m:mo>cos</m:mo>
      </xsl:when>
      <xsl:when test="@name='cosh'">
        <m:mo>cosh</m:mo>
      </xsl:when>
      <xsl:when test="@name='cot'">
        <m:mo>cot</m:mo>
      </xsl:when>
      <xsl:when test="@name='coth'">
        <m:mo>coth</m:mo>
      </xsl:when>
      <xsl:when test="@name='csc'">
        <m:mo>csc</m:mo>
      </xsl:when>
      <xsl:when test="@name='csch'">
        <m:mo>csch</m:mo>
      </xsl:when>
      <xsl:when test="@name='exp'">
        <m:mo>exp</m:mo>
      </xsl:when>
      <xsl:when test="@name='ln'">
        <m:mo>ln</m:mo>
      </xsl:when>
      <xsl:when test="@name='log'">
        <m:mo>log</m:mo>
      </xsl:when>
      <xsl:when test="@name='sec'">
        <m:mo>sec</m:mo>
      </xsl:when>
      <xsl:when test="@name='sech'">
        <m:mo>sech</m:mo>
      </xsl:when>
      <xsl:when test="@name='sin'">
        <m:mo>sin</m:mo>
      </xsl:when>
      <xsl:when test="@name='sinh'">
        <m:mo>sinh</m:mo>
      </xsl:when>
      <xsl:when test="@name='tan'">
        <m:mo>tan</m:mo>
      </xsl:when>
      <xsl:when test="@name='tanh'">
        <m:mo>tanh</m:mo>
      </xsl:when>
      <xsl:otherwise>
        <m:mo><xsl:value-of select="@cd"/>:<xsl:value-of select="@name"/></m:mo>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="om:OMS[@cd='setname1']">
    <xsl:choose>
      <xsl:when test="@name='N'">
        <m:mo>N</m:mo>
      </xsl:when>
      <xsl:when test="@name='Z'">
        <m:mo>Z</m:mo>
      </xsl:when>
      <xsl:when test="@name='Q'">
        <m:mo>Q</m:mo>
      </xsl:when>
      <xsl:when test="@name='R'">
        <m:mo>R</m:mo>
      </xsl:when>
      <xsl:otherwise>
        <m:mo><xsl:value-of select="@cd"/>:<xsl:value-of select="@name"/></m:mo>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="om:OMS[@cd='simpletypes']">
    <xsl:choose>
      <xsl:when test="@name='funtype'">
        <m:mo>&RightArrow;</m:mo>
      </xsl:when>
      <xsl:otherwise>
        <m:mo><xsl:value-of select="@cd"/>:<xsl:value-of select="@name"/></m:mo>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="om:OMS[@cd='org.matracas.algebra']">
    <m:mo><xsl:value-of select="@name"/></m:mo>
  </xsl:template>
  
</xsl:stylesheet>
