///////////////////////////////////////////////////////////////////////////
//
//   Copyright 2006 Alberto González Palomo
//   Author: Alberto González Palomo <http://www.matracas.org>
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
/////////////////////////////////////////////////////////////////////////////

const xul_namespace = 'http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul';
const xhtml_namespace = 'http://www.w3.org/1999/xhtml';

function init()
{
  append_new_input(1);
}

function keydown_input(event)
{
  var input;
  input = event.target;
  
  var at_end_of_input;
  at_end_of_input = (input.selectionStart == input.value.length);
  
  switch (event.keyCode)
    {
    case event.DOM_VK_BACK_SPACE:
      input.setAttribute("rows", input.value.replace(/./g, "").length + 1);
      break;
    case event.DOM_VK_RETURN:
      input.setAttribute("rows", input.value.replace(/./g, "").length + 1);
      break;
    }
}

function keyup_input(event)
{
  var input;
  input = event.target;
  
  var at_end_of_input;
  at_end_of_input = (input.selectionStart == input.value.length);
  
  switch (event.keyCode)
    {
    case event.DOM_VK_RETURN:
      if (input.value && at_end_of_input && input.value.match(/;\s*$/))
        {
          enter_input(input);
        }
      else
        {
          input.setAttribute("rows", input.value.replace(/./g, "").length + 1);
        }
      break;
    case event.DOM_VK_ENTER:
      enter_input(input);
      break;
    case event.DOM_VK_BACK_SPACE:
      input.setAttribute("rows", input.value.replace(/./g, "").length + 1);
      break;
    }
}

function enter_input(input)
{
  var current_input;
  current_input = input;
  var output;
  var output_id;
  output_id = input.id.replace('input', 'output');
  output = document.getElementById(output_id);
  if (!output)
    {
      var output_container;
      output_container = document.createElementNS(xul_namespace, 'hbox');
      output_container.setAttribute("class", "output");
      output_container.setAttribute("flex", 1);
      output = document.createElementNS(xhtml_namespace, 'p');
      output.setAttribute('id', output_id);
      input.parentNode.appendChild(output);
      current_input = append_new_input(parseInt(input.id.replace("input", ""))
                                       + 1);
    }
  
  output.innerHTML = evaluate(input);
  
  current_input.focus();
}

function append_new_input(index)
{
  var new_input;
  //new_input = new XML('<input class="input" onchange="changed_input(this)"/>');
  new_input = document.createElementNS(xhtml_namespace, "textarea");
  new_input.setAttribute("multiline", "true");
  new_input.setAttribute("rows", "1");
  new_input.setAttribute("onkeydown", "keydown_input(event)");
  new_input.setAttribute("onkeyup",     "keyup_input(event)");
  new_input.setAttribute("id", "input" + index);
  var input_container;
  input_container = document.createElementNS(xhtml_namespace, "li");
  input_container.setAttribute("class", "input");
  
  input_container.appendChild(new_input);
  document.getElementById("notebook-body").appendChild(input_container);
  return new_input;
}

function evaluate(input)
{
  var input_expression;
  
  if (input.value.match(/%/))
    {
      var previous_input;
      previous_input = document
        .getElementById("input" + (parseInt(input.id.replace("input", ""))-1));
      if (previous_input)
        {
          if (previous_input == input)
            {
              alert("Error: infinite recursion found.");
              return "[error]";
            }
          
          input_expression = input.value.replace(/%/g,
                                                 evaluate(previous_input)
                                                 );
        }
      else
        {
          input_expression = "";
        }
    }
  else
    {
      input_expression = input.value;
    }
  
  var result;
  try
    {
      result = eval(input_expression);
    }
  catch (exception)
    {
      result = exception + ", in <code class='user-input-quote'>" + input_expression + "</code>";
    }
  
  return result;
}
