///////////////////////////////////////////////////////////////////////////
//
//   Copyright 2006 Alberto González Palomo
//   Author: Alberto González Palomo <http://www.matracas.org>
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
/////////////////////////////////////////////////////////////////////////////

const xhtml_namespace = "http://www.w3.org/1999/xhtml";

function make_row(type, content, index)
{
  var row;
  row = document.createElementNS(xhtml_namespace, "tr");
  row.setAttribute("class", type);
  var prompt;
  prompt = document.createElementNS(xhtml_namespace, "td");
  prompt.setAttribute("class", type + "-prompt");
  var container;
  container = document.createElementNS(xhtml_namespace, "td"); 
  container.setAttribute("class", type + "-container");
  container.appendChild(content);
  var closure;
  closure = document.createElementNS(xhtml_namespace, "td");
  closure.setAttribute("class", type + "-closure");
  
  row.appendChild(prompt);
  row.appendChild(container);
  row.appendChild(closure);
  
  return row;
}

function new_notebook_entry(index)
{
  var input_text_field;
  //input_text_field = new XML('<input class="input" onchange="changed_input(this)"/>');
  input_text_field = document.createElementNS(xhtml_namespace, "textarea");
  input_text_field.setAttribute("rows", "1");
  input_text_field.setAttribute("onkeydown", "keydown_input(event)");
  input_text_field.setAttribute("onkeyup",     "keyup_input(event)");
  input_text_field.setAttribute("class", "input-text-field");
  input_text_field.setAttribute("id", "input" + index);
  
  var new_computation;
  new_computation = document.createElementNS(xhtml_namespace, "table");
  new_computation.setAttribute("width", "100%");
  new_computation.setAttribute("class", "computation-frame");
  var notebook_entry;
  notebook_entry = document.createElementNS(xhtml_namespace, "table");
  notebook_entry.setAttribute("width", "100%");
  notebook_entry.setAttribute("class", "notebook-entry");
  
  new_computation.appendChild(make_row("input", input_text_field));
  notebook_entry.appendChild(make_row("computation", new_computation));
  
  return notebook_entry;
}

function create_output_node_for_notebook_entry(input, index)
{
  var new_output;
  new_output = document.createElementNS(xhtml_namespace, 'div');
  new_output.setAttribute("class", "output-content");
  new_output.setAttribute('id', "output" + index);
  
  var node;
  node = input;
  while (node.parentNode && node.getAttribute("class") != "input")
    node = node.parentNode;
  if (node.getAttribute("class") == "input")
    {
      node = node.parentNode;
      node.appendChild(make_row("output", new_output, index));
    }
  else
    {
      alert("input container not found: " + node.nodeName);
    }
  
  return new_output;
}
